From bf53232cea7ee8103a8065a4cc7a213bbe03479e Mon Sep 17 00:00:00 2001
From: Francois Andrieu <darknao@fedoraproject.org>
Date: Feb 09 2022 06:04:30 +0000
Subject: [PATCH 81/88] try to preserve hardlinks while building


---

diff --git a/build-scripts/rebuild-site.py b/build-scripts/rebuild-site.py
index 4212b7b..2679a1d 100755
--- a/build-scripts/rebuild-site.py
+++ b/build-scripts/rebuild-site.py
@@ -446,6 +446,7 @@ def main():
                 log("  {lang} done".format(lang=lang))
 
             # Building all the translated sites
+            lastlang = list(languages)[-1]
             for lang in languages:
                 log("")
                 log("===== Building the {lang} site =====".format(lang=lang))
@@ -464,6 +465,7 @@ def main():
                 results_dir = os.path.join(docs_repo, "public", lang)
                 publish_dir = f"/antora/output/{lang}"
                 copying_dir = f"/antora/output/{lang}.tmp"
+                lastlang_dir = f"/antora/output/{lastlang}"
 
                 # I have:
                 # docs_repo/public/xx         <- results_dir  (local partition)
@@ -490,8 +492,12 @@ def main():
                 log(f"Moving language to the final place: {copying_dir} to {publish_dir}")
                 shutil.rmtree(publish_dir, ignore_errors=True)
                 subprocess.run(["mv", copying_dir, publish_dir])
-                log("hardlinking files...")
-                subprocess.run(["hardlink", "-v", publish_dir])
+
+                # Recreate hardlinks as we go, in case the rsync job
+                # start while we are still building
+                if (lang != lastlang):
+                    log(f"hardlinking files: {publish_dir} - {lastlang_dir}")
+                    subprocess.run(["hardlink", "-cv", publish_dir, lastlang_dir])
 
                 # Remove local build
                 shutil.rmtree(results_dir, ignore_errors=True)
@@ -500,7 +506,7 @@ def main():
 
             # https://pagure.io/fedora-infrastructure/issue/8964
             log("Consolidate files with hardlink...")
-            subprocess.run(["hardlink", "-v", "/antora/output/"])
+            subprocess.run(["hardlink", "-cv", "/antora/output/"])
 
             log("DONE!")
     
